{-| Module      : Graph.BAC.Clustering
Description : Proxemy
Copyright   : (c) CNRS, 2017-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

{-# LANGUAGE NoImplicitPrelude #-}

module Graph.BAC.Clustering
  where

import Graph.BAC.Clustering.Types
import Graph.Lib.FGL (Node)
import Graph.Tools.Import (GraphData(..))
import Graph.Tools.Import (GraphData(LightGraph, LabelledGraph))
import Protolude
import qualified Data.Graph.Inductive       as DGI
import qualified Graph.BAC.Clustering.Eigen as Optim
import qualified Graph.BAC.Clustering.Safe  as Safe

data ClusteringType = Safe | Optim

getClusters :: ClusteringType -> Length -> GraphData -> Clustering Node
getClusters Optim l (LightGraph g)    = Optim.withG g (Optim.clustering 3 Conf)
getClusters Safe  l (LightGraph g)    = Safe.clusterGraph l (DGI.emap (\_ -> 1.0) g)
getClusters Safe  l (LightWeightedGraph g)    = Safe.clusterGraph l g
getClusters Safe  l (LabelledGraph g) = Safe.clusterGraph l g
